from wmd.UI.Logger import *

# These are valid event types
# Eventually, it would be nice to have validation built-in for each event type

UI_INFO = "UI_INFO"

UI_INFO_CONNECTED = [ UI_INFO, "CONNECTED" ]
UI_INFO_CONNECTING = [ UI_INFO, "CONNECTING" ]

# Here are events sent by the WiiMote
WM_IR = "WM_IR"    # self.ev.send( WM_IR, [pdots, dots_on] )
WM_ACC = "WM_ACC"  # Accelerometer data, { 'x':x, 'y':y, 'z':z }
WM_BT = "WM_BT"    # Button press, [bt, state] where state in ['UP', 'DOWN']

# Classic Controller and Nunchuk events
WM_EXT_BT = "WM_EXT_BT"            # Buttons events in [ 'UP', 'DOWN' ] (Nunchuk/CC)
WM_EXT_ANALOG = "WM_EXT_ANALOG"    # Analog Axes (Joysticks/Triggers, Nunchuk/CC)
WM_EXT_ACC = "WM_EXT_ACC"          # Accelerometer Data (Nunchuk)

ABS_POS = "ABS_POS" # [sx, sy]
REL_POS = "REL_POS" # [rx, ry]

REL_TILT = "REL_TILT"

SET_LED = "SET_LED" # on|off|toggle, led

EV_SHUTDOWN = "EV_SHUTDOWN" #Time to quit!

EVBR_KEYUP = "EVBR_KEYUP"     # Send keyup to event bridge
EVBR_KEYDOWN = "EVBR_KEYDOWN" # Send keydown ...

WMDPOWER = "WMDPOWER"

WM_CLOCK_BEAT = "WM_CLOCK_BEAT" # This is a beat, comes in whenever we have an inbound report... Useful for forcing event handling

UI_SWITCH = "UI_SWITCHED" # Use next available UI


class bf(object):
    def __init__(self,value=0):
        self._d = value

    def __getitem__(self, index):
        return (self._d >> index) & 1 

    def __setitem__(self,index,value):
        value    = (value&1L)<<index
        mask     = (1L)<<index
        self._d  = (self._d & ~mask) | value

    def __getslice__(self, start, end):
        mask = 2L**(end - start) -1
        return (self._d >> start) & mask

    def __setslice__(self, start, end, value):
        mask = 2L**(end - start) -1
        value = (value & mask) << start
        mask = mask << start
        self._d = (self._d & ~mask) | value
        return (self._d >> start) & mask

    def __int__(self):
        return self._d


# Global Definitions

# Features and feature types..

#WIIMOTE = {
#  'name': 'NINTENDO RVLfddfdf',
#  'buttons': [
#    BT_1: '1',
#    BT_2: '2',
#    BT_LESS: '-',
#    B_HOME: 'H',
#    BT_PLUS: '+',
#    BT_A: 'A',
#    BT_B: 'B',
#    BT_NORTH: "U",
#    BT_SOUTH: "D",
#    BT_EAST: "R",
#    BT_WEST: "L"
#  ],


