# WMD 0.2 - Event Dispatcher

# This is somewhat of a mess.

# Events need to be routed alongside buses, and events need to be described on publication.
# The performance of the event system isn't so important for now.
# Events should be possible to validate.


from wmd.EventBridges.PyXlib import EventBridge_PyXlib
from wmd.EventBridges.uinput import EventBridge_uinput
from wmd.Common import *
import weakref

class EVDispatcher:
  cl = 0
  valid_evtypes = [ # Accept only these event types
    WM_IR, WM_ACC, WM_BT, WM_CLOCK_BEAT,
    WM_EXT_BT, WM_EXT_ANALOG, WM_EXT_ACC,
    UI_INFO, UI_SWITCH,
    ABS_POS, REL_POS, SET_LED,
    EV_SHUTDOWN, REL_TILT,
    EVBR_KEYUP, EVBR_KEYDOWN, WMDPOWER
  ] # To create a new event type, you must add it to Common.py

  subs = {}
  ignored_evtypes = []

  def __init__( self, cf ):
    self.cf = cf
    if self.cf['IO_MODES']['XLIB']:
      self.xlib = EventBridge_PyXlib( self, cf )

    if self.cf['IO_MODES']['UINPUT']:
      self.uinput = EventBridge_uinput( self, cf )

  def send( self, evtype, payload ):
    if evtype in self.valid_evtypes:
      if self.subs.has_key( evtype ):
        dests = self.subs[evtype]
	for dest in dests:
	  if dest:
  	    dest( payload )
      else:
        if not evtype in self.ignored_evtypes:
	  self.ignored_evtypes.append( evtype )
          log( LOG_EV, "Event type %s is being ignored" % ( evtype ) )
    else:
      log( LOG_ERR, "%s is not a valid event type" % ( evtype ) )

  def subscribe( self, evtype, callback ):
    if not self.subs.has_key( evtype ):
      self.subs[evtype] = []
#    weak_callback = weakref.proxy( callback )
    self.subs[evtype].append( callback )
#    print "registering %s for %s" % (evtype, callback.func_name, callback.im_self)

  def unsubscribe( self, evtype, callback ):
    if self.subs.has_key( evtype ):
      i = self.subs[evtype].index( callback )
      self.subs[evtype][i] = None
      print "unregistered"
  
  def click_lock( self ):
    self.cl = 10

  def is_click_locked( self ):
    if self.cl == 0:
      return 0
    else:
      self.cl -= 1
      return self.cl
      

class Event:
  def __init__( self ):
    pass

class AxesEvent(Event):
  sources = [ "WiiMote", "Classic", "Nunchuk" ]

  types = [ "Joystick", "IR", "Trigger", "Accelerometer" ]

  orientations = [ 'x', 'y', 'z' ]

  numAxises = [ 1, 3 ]
  
  precisions = [ 5, 6, 8, 10 ]
 
  ranges = [ [ 0.0, 1.0 ], [ -1.0, 1.0 ] ]

class KeyEvent(Event):
  states = [ 'UP', 'DOWN' ]


