# Interesting filter examples, not in use yet

import math
import FFT
import Numeric

TRUE = (1==1)
FALSE = not TRUE
True = TRUE
False = FALSE

GoldenRatio = ( 1.0 + math.sqrt(5.0) ) / 2.0
 
class Filter:
    def set_cutoff(self,cutoff):
        self.cutoff = cutoff

    def set_band(self,f1, f2):
        self.f1 = f1
        self.f2 = f2
        
    def filter(self,x,y):
        self.delta = x[1] - x[0]
        self.f_Nyquist = 1.0 / 2.0 / self.delta
        self.N = len(x)

        self.fft = FFT.fft(y)

        self.freqs = Numeric.array(range(len(self.fft))) / self.delta / len(self.fft)
        N = len(self.freqs)
        for i in range(N/2):
            self.freqs[N/2+i] = - self.freqs[N/2-i]

        self.calculate_condition()
        #for i in range(len(self.freqs)):
        #    print '%10d %10f %2d' % ( i, self.freqs[i], self.cond[i] )
        self.filtered_fft = self.cond * self.fft
        self.filtered_y = FFT.inverse_fft(self.filtered_fft)

        return self.filtered_y

    def calculate_condition(self):
        pass
    
class HighPassFilter(Filter):
    def calculate_condition(self):
        self.cond = Numeric.greater_equal( abs(self.freqs), self.cutoff )
    
class LowPassFilter(Filter):
    def calculate_condition(self):
        self.cond = Numeric.less_equal( abs(self.freqs), self.cutoff )

class BandPassFilter(Filter):
    def calculate_condition(self):
        self.cond = Numeric.logical_and(
            Numeric.greater( abs(self.freqs), self.f1 ),
            Numeric.less(    abs(self.freqs), self.f2 ) )

class BandRejectFilter(Filter):
    def calculate_condition(self):
        self.cond = Numeric.logical_or(
            Numeric.less(    abs(self.freqs), self.f1 ),
            Numeric.greater( abs(self.freqs), self.f2 ) )

class LineFilter(Filter):
    def __init__(self):
        self.set_line_frequency(60.0)
        self.set_max_harmonic(5)
        self.set_width(2.0)
        
    def set_line_frequency(self,f):
        self.line_frequency = f

    def set_max_harmonic(self,n):
        self.max_harmonic = n

    def set_width(self,w):
        self.width = w

    def calculate_condition(self):
        self.cond = Numeric.greater( abs(self.freqs), -1.0 )
        for i in range(1,self.max_harmonic+1):
            f1 = i * self.line_frequency - self.width / 2.0
            f2 = i * self.line_frequency + self.width / 2.0
            print i, f1, f2
            cond = Numeric.logical_or(
                Numeric.less(    abs(self.freqs), f1 ),
                Numeric.greater( abs(self.freqs), f2 ) )
            self.cond = Numeric.logical_and( self.cond, cond )
