from wmd.Common import *
from wmd.UI.PyGAccelGrapher import PyGAccelGrapher
from wmd.UI.PyGIRDisplay import PyGIRDisplay
from wmd.UI.PyGExtAnalog import PyGExtAnalog


class UIManager:
  PyGDisplays = [ PyGIRDisplay, PyGExtAnalog, PyGAccelGrapher ]
  PyGDisplayIndex = 0
  pygd = None

  def __init__( self, cf, ev ):
    ev.subscribe( UI_INFO, self.ev_ui_info )

    self.ev = ev
    self.cf = cf

    if not self.cf['DISABLE_PYGAME']:
      self.start_PyGDisplay()

    ev.subscribe( UI_SWITCH, self.next_PyGDisplay )

  def start_PyGDisplay( self ):
    self.pygd = self.PyGDisplays[ self.PyGDisplayIndex ]( self.ev )

  def next_PyGDisplay( self, evi ):
    if self.cf['DISABLE_PYGAME']:
      return

    if evi != 'next':
      return

    if self.pygd != None:
      self.pygd.stop()

    i = self.PyGDisplayIndex

    if i == len( self.PyGDisplays ) - 1:
      i = -1
      self.pygd = None
    else:
      i += 1
      self.pygd = self.PyGDisplays[i]( self.ev )

    self.PyGDisplayIndex = i

  def ev_ui_info( self, message ):
    print message
  
  def pre_connect( self ):
    pass

  def connected( self ):
    pass

  def log( self, level, msg ):
    pass
