#!/bin/bash
#   /usr/local/bin/ripD_eject.sh
#	A DVD rip and eject script.
########################################################################
DEV='/dev/dvd'				# DVD device
MPNT='/cdrom'				# Mount Point
Ddir='/media/video /myth/video'		# DVD output dir List
Bsnd='/usr/share/sounds/init.wav'	# Begin sound file
Esnd='/usr/share/sounds/complete.wav'	# End   sound file
DATE=$(date +%Y%m%d_%H%M)		# current date/time
LOG='/tmp/ripD.log'			# name of Log file.
#-----------------------------------------------------------------------
FONT="-adobe-helvetica-bold-*-*-*-34-*-*-*-*-*-*-*"
OPTS="-f $FONT -s 2 -p bottom -A left -i 50 -l 4"
#-----------------------------------------------------------------------
[ -r /etc/rip.cfg ] && . /etc/rip.cfg
#-----------------------------------------------------------------------
LOCK=/tmp/.ripLock.$$
[ "$DISPLAY" == "" ] && export DISPLAY=:0
########################################################################
function osd { # $1=text, $2=color, $3=delay
    cmd="osd_cat $OPTS"
    [ -n "$2" ] && cmd="$cmd --color=$2"
    [ -n "$3" ] && cmd="$cmd -d $3"
    killall osd_cat
    echo -e "$1" | $cmd
} >& /dev/null
function osd_loop() {
    FN=$1 ; shift
    TXT="$MAX  to  $dir"
    N=0
    while [ -f "$LOCK" ]; do
	osd "\nbackup DVD:  '$@'\n$TXT" gray 60
	N=$(($N+1))
	[ -d "$FN" ] && SIZE=$(du -sh $FN | awk '{print $1}')
	TXT="$SIZE of $MAX @ $N min. elapsed"
    done
}
########################################################################
KnoppMyth-osd "\ndetected DVD" gray20 5 &
echo "`date` detected DVD" >> $LOG
rm -f /tmp/.ripLock.*
#=======================================================================
for dir in $Ddir ; do
    if [ -d $dir -a -w $dir ]; then
	break
    fi
done
#-----------------------------------------------------------------------
if [ ! -d "$dir" ]; then
    echo "no $dir" >> $LOG
    osd "\ndirectory:  $dir\nnot found!" red 10 &
    eject ; eject
    exit 0
fi
if [ ! -w "$dir" ]; then
    echo "$dir not writable" >> $LOG
    osd "\ndirectory:  $Cdir\nnot writable!" red 10 &
    eject ; eject
    exit 0
fi
#-----------------------------------------------------------------------
mount $DEV >& /dev/null
dev=$(readlink $DEV)
df=$(df -h /dev/$dev | grep /dev/$dev)
MAX=$(echo $df | while read d v r ; do echo $v ; done)
echo " backup $MAX to $dir" >> $LOG
#=======================================================================
# first make sure DMA is on:
sudo hdparm -d1 -u1 $DEV >& /dev/null
# attempt to get the DVD information:
TITLE=$(dvdbackup -i /dev/dvd -I | grep information | awk '{print $8}')
if [ "$TITLE" == "DVD_VIDEO" -o "$TITLE" == "" \
	-o "$TITLE" == " " -o "$TITLE" == "[ ].*" ]; then
    # if not a good title,
    TITLE="dvdbackup_$DATE"
fi
echo " $TITLE" >> $LOG
{ # for the redir below:
    # Begin:
    touch $LOCK
    osd_loop "$dir/$TITLE" "$TITLE" &
    dvdbackup -i $DEV -I
###    sleep 1 ; play --silent $Bsnd
    vobcopy -i $MPNT -m -t $TITLE -o $dir
    #dvdbackup -M -i $DEV -o $dir -n $TITLE
    #time dd if=$DEV of=$dir/$TITLE.iso bs=2048 
    # Finish:
    rm -f $LOCK
    osd "\nfinish DVD:  '$TITLE'\ninto $dir" gray20 5 &
###    sleep 1 ; play --silent $Esnd
    # Eject the media:
    sudo eject ; sudo eject
} > $dir/.$TITLE.log 2>&1
echo " `du -sh $dir/$TITLE`" >> $LOG
echo " `date` finished DVD"  >> $LOG
exit 0
########################################################################
# End
